(****************************************************************************
*                                                                           *
*  Copyright 1996 bei Stefan Graf (CompuServe: 100736.2464)                 *
*                                                                           *
*****************************************************************************)
unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, ExtCtrls,
  Capi2Con, Capi2Typ, Capi2Han,Capi2Bas, T30Protokoll;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    Exit1: TMenuItem;
    Info1: TMenuItem;
    Test1: TMenuItem;
    Memo2: TMemo;
    Call1: TMenuItem;
    Digital: TMenuItem;
    Analog: TMenuItem;
    Send1: TMenuItem;
    Setzen1: TMenuItem;
    Aus1: TMenuItem;
    testtxt1: TMenuItem;
    Select1: TMenuItem;
    OpenFileDialog: TOpenDialog;
    Anmelden1: TMenuItem;
    Abmelden1: TMenuItem;
    Disconnect1: TMenuItem;
    Timer1: TTimer;
    Telephony1: TMenuItem;
    Daten1: TMenuItem;
    FaxG31: TMenuItem;
    FaxG41: TMenuItem;
    Ein1: TMenuItem;
    FacilityMenu: TMenuItem;
    DTMF1: TMenuItem;
    FacilitySupport: TMenuItem;
    Setup1: TMenuItem;
    DigitakX251: TMenuItem;
    Packet1: TMenuItem;
    Protokoll1: TMenuItem;
    Daten2: TMenuItem;
    Voice1: TMenuItem;
    Fax1: TMenuItem;
    Connect1: TMenuItem;
    Set1: TMenuItem;
    Reset1: TMenuItem;
    Memo3: TMemo;
    Handset1: TMenuItem;
    Suspend1: TMenuItem;
    Resume1: TMenuItem;
    ListenDTMF1: TMenuItem;
    DTMF2: TMenuItem;
    Ein2: TMenuItem;
    Aus2: TMenuItem;
    Reset2: TMenuItem;
    ExtFax1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure Info1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Capi1Confirm (Sender:TObject; const CommandID : Cardinal; const Daten : ConfirmDatenType; var ErrorCode : Cardinal; var Done : Boolean);
    procedure Capi1Error(Sender: TObject; const CommandID, SubCommand, ErrorNumber: Cardinal);
    procedure Capi1Info(Sender: TObject; const Info: Cardinal; var InfoDaten: CapiParameterType);
    procedure Capi1MessageDump (Sender: TObject; const CommandID, SubCommand : Cardinal; var Daten: ReceiveDatenType);
    procedure Capi1Connect(Sender: TObject);
    procedure Capi1Disconnect(Sender: TObject; const Grund : Cardinal);
    procedure Capi1DataConnect(Sender: TObject; const Kanal : BKanalType);
    function  Capi1ReqBConnect(Sender:TObject; const DestNCPI : CapiParameterType; var NCPI : CapiParameterType) : Boolean;
    procedure Capi1Receive(Sender: TObject; const Kanal : BKanalType; const Count: Cardinal);
    procedure Capi1ReceiveDTMF (Sender:TObject; const Taste : char);
    procedure DigitalClick(Sender: TObject);
    procedure AnalogClick(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    function  Capi1Ring(Sender: TObject;const CallDaten : TCallDaten) : Cardinal;
    procedure FormCreate(Sender: TObject);
    procedure Ein1Click(Sender: TObject);
    procedure Aus1Click(Sender: TObject);
    procedure testtxt1Click(Sender: TObject);
    procedure Select1Click(Sender: TObject);
    procedure DTMF1Click(Sender: TObject);
    procedure Anmelden1Click(Sender: TObject);
    procedure Abmelden1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Connect1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Telephony1Click(Sender: TObject);
    procedure Daten1Click(Sender: TObject);
    procedure FAXG31Click(Sender: TObject);
    procedure FAXG41Click(Sender: TObject);
    procedure FacilitySupportClick(Sender: TObject);
    procedure Setup1Click(Sender: TObject);
    procedure DigitalX25Click(Sender: TObject);
    procedure Packet1Click(Sender: TObject);
    procedure Daten2Click(Sender: TObject);
    procedure Voice1Click(Sender: TObject);
    procedure Fax1Click(Sender: TObject);
    procedure Set1Click(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure Handset1Click(Sender: TObject);
    procedure CapiGetProtokoll (Sender:TObject; const NCPI : CapiParameterType);
    procedure CapiSetProtokoll (Sender:TObject; var Param : CapiBProtocolType);
    procedure Suspend1Click(Sender: TObject);
    procedure Resume1Click(Sender: TObject);
    procedure ListenDTMF1Click(Sender: TObject);
    procedure Ein2Click(Sender: TObject);
    procedure Aus2Click(Sender: TObject);
    procedure Reset2Click(Sender: TObject);
    procedure ExtFax1Click(Sender: TObject);
  private
    {$IFDEF Debug}
      LogFile : TextFile;
    {$ENDIF}

    DataKanal : BKanalType;
    recvflag : Boolean;
    recvfile : File;
    FaxRecvInfo : TFaxRecvInfo;
  public
    Capi1 : TCapi20Handler;
  end;

var
  Form1: TForm1;

implementation

uses MainConf;

{$R *.DFM}

procedure TForm1.Info1Click(Sender: TObject);
var
  line    : String;
  support : Cardinal;
begin
  if not (Capi1.CapiAvailable) then
    Capi1.OnError (Capi1,0,0,$6002)
  else begin
    Memo1.Lines.Add (Capi1.GetHersteller + ' / ' + Capi1.GetVersion + ' / ' + Capi1.GetSerialNumber);

    Memo1.Lines.Add ('B-Kanle     : ' + IntToStr (Capi1.GetAnzahlBCannel (1)));

    support := Capi1.GetOptionen (1);
    Memo1.Lines.Add ('Optionen     : 0x' + IntToHex (support,8));

    line := '|';
    if ((support and $01) <> 0) then
      line := line + 'int|';
    if ((support and $02) <> 0) then
      line := line + 'extrn|';
    if ((support and $04) <> 0) then
      line := line + 'handset|';
    if ((support and $08) <> 0) then
      line := line + 'DTMF|';
    if ((support and $10) <> 0) then
      line := line + 'Supp|';
    if ((support and $20) <> 0) then
      line := line + 'ch alloc|';

    Memo1.Lines.Add ('               ' + line);

    support := Capi1.GetSupportedB1Protokoll (1);

    Memo1.Lines.Add ('B1-Protokolle: ' + IntToHex (support,8));
    line := '';
    if ((support and $0001) <> 0) then
      line := line + '|HDLC 64K';
    if ((support and $0002) <> 0) then
      line := line + '|TRANS 64K';
    if ((support and $0004) <> 0) then
      line := line + '|V110 async';
    if ((support and $0008) <> 0) then
      line := line + '|V.110 sync';
    if ((support and $0010) <> 0) then
      line := line + '|T.30';
    if ((support and $0020) <> 0) then
      line := line + '|inv HDLC 64K';
    if ((support and $0040) <> 0) then
      line := line + '|HDLC 56K';
    if ((support and $0080) <> 0) then
      line := line + '| Modem';
    if ((support and $0100) <> 0) then
      line := line + '| async Modem';
    if ((support and $0200) <> 0) then
      line := line + '| sync Modem';
    Memo1.Lines.Add ('               ' + line);


    support := Capi1.GetSupportedB2Protokoll (1);

    Memo1.Lines.Add ('B2-Protokolle: ' + IntToHex (support,8));
    line := '';
    if ((support and $0001) <> 0) then
      line := line + '|X.75';
    if ((support and $0002) <> 0) then
      line := line + '|BITTRANS';
    if ((support and $0004) <> 0) then
      line := line + '|SDLC';
    if ((support and $0008) <> 0) then
      line := line + '|LAPD';
    if ((support and $0010) <> 0) then
      line := line + '|T.30';
    if ((support and $0020) <> 0) then
      line := line + '|PPP';
    if ((support and $0040) <> 0) then
      line := line + '|TRANSPARENT';
    if ((support and $0080) <> 0) then
      line := line + '|Modem';
    if ((support and $0100) <> 0) then
      line := line + '|X.75&V.42bis';
    if ((support and $0200) <> 0) then
      line := line + '|V.120';
    if ((support and $0400) <> 0) then
      line := line + '|V.120&V.42bis';
    if ((support and $0800) <> 0) then
      line := line + '|V.120 transp';
    Memo1.Lines.Add ('               ' + line);

    support := Capi1.GetSupportedB3Protokoll (1);

    Memo1.Lines.Add ('B3-Protokolle: ' + IntToHex (support,8));
    line := '';
    if ((support and $0001) <> 0) then
      line := line + '|TRANSPARENT';
    if ((support and $0002) <> 0) then
      line := line + '|T.90NL';
    if ((support and $0004) <> 0) then
      line := line + '|ISO 8208';
    if ((support and $0008) <> 0) then
      line := line + '|X25';
    if ((support and $0010) <> 0) then
      line := line + '|T.30';
    if ((support and $0020) <> 0) then
      line := line + '|ext. T.30';
    if ((support and $0080) <> 0) then
      line := line + '|Modem';
    Memo1.Lines.Add ('               ' + line);
  end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  if (Capi1.ApplicationRegistered) then begin
    Capi1.DisconnectLine (9);

    Capi1.EnableListen ([]);
  end;

  Close;
end;

procedure TForm1.Capi1MessageDump (Sender: TObject; const CommandID, SubCommand : Cardinal; var Daten: ReceiveDatenType);
var
  i    : Integer;
  line : String;
begin
  line := Capi1.GetCommandStr (CommandID,SubCommand);

  if (SubCommand = CONF) then begin
    case CommandID of
      DATA_B3 :
        line := line + ' Block: ' + IntToStr (Daten.ConfData.DataB3Conf.BlockNr);
    end;
  end else with Daten.IndData do begin
    case CommandID of
      DATA_B3 :
        line := line + ' Block: ' + IntToStr (DataB3Ind.BlockNr) + ' Size: ' + IntToStr (DataB3Ind.DataSize);

      DISCONNECT :
        line := line + ' 0x' + IntToHex (DisconnectInd.Reason,4);

      INFO : begin
        line := 'Info (' + IntToHex (InfoInd.InfoNr,4) + ') ';
        if ((InfoInd.InfoNr and $8000) = 0) then begin
          for i := 1 to Ord (InfoInd.Info [0]) do
            line := line + ' ' + IntToHex (Ord (InfoInd.Info [i]),2);
        end;
      end;

      CONNECT : begin
        line := 'Service : ' + IntToStr (ConnectInd.CIPValue);

        if (Ord (ConnectInd.BC [0]) > 0) then begin
          line := line + ' / Bearer Capability:';
          for i:= 1 to Ord (ConnectInd.BC [0]) do
            line := line + ' 0x' + IntToHex (Ord (ConnectInd.BC [i]),2);
        end;
      end;
    end;
  end;

  line := Copy (line,1,60);
  Memo1.Lines.Add (line);
end;

procedure TForm1.Capi1Confirm (Sender:TObject; const CommandID : Cardinal; const Daten : ConfirmDatenType; var ErrorCode : Cardinal; var Done : Boolean);
var
  line : String;
  SubInfo : Word;
  SubSupport : LongInt;
begin
  if (CommandID = FACILITY) then with daten.FacilityConf Do begin
    if (Info = 0) and (Selector = SelectorSupService) and (SupService.Funct = SupSupported) then begin
      Move (SupService.Param [1], SubInfo, 2);
      Move (SupService.Param [3], SubSupport, 4);

      line := '';

      if ((SubSupport and $01) <> 0) then
        line := line + 'Hold/Retrieve|';

      if ((SubSupport and $02) <> 0) then
        line := line + 'Term. Port. support|';

      if ((SubSupport and $04) <> 0) then
        line := line + 'ECT|';

      if ((SubSupport and $08) <> 0) then
        line := line + '3PTY|';

      if ((SubSupport and $10) <> 0) then
        line := line + 'Call-Forwd.|';

      if ((SubSupport and $20) <> 0) then
        line := line + 'Call-Defl.|';

      Memo1.Lines.Add ('Supp. Services: ' + line);
    end;
  end;
end;

procedure TForm1.Capi1Error(Sender: TObject; const CommandID, SubCommand, ErrorNumber: Cardinal);
begin
  MessageDLG (Capi1.GetCommandStr (CommandID,SubCommand) + ' : ' + Capi1.GetErrorStr (ErrorNumber), mtWarning, [mbOK], 0);
end;

function TForm1.Capi1Ring(Sender: TObject;const CallDaten : TCallDaten) : Cardinal;

const
  ServiceStr : array [0..9] of String [20] = ('','TELEPHONY (1TR6)','ANALOG_TELEPHONY','DIGITAL_TELEPHONY',
                                              'FAX3','FAX4','DATA_64K','DATA_56K','PACKET_MODE','UNKNOWN');
var
  line : String;
  tonumstr,
  fromnumstr : String;

begin
  with CallDaten do begin
    tonumstr := Copy (CallTo,2,255);
    fromnumstr := Copy (CallFrom,3,255);

    line := 'Call from (0x' + IntToHex (Ord (CallFrom [1]), 2) + '/0x' + IntToHex (Ord (CallFrom [2]), 2) + ') ' + fromnumstr + '(' + SubFrom + ')' + ' to (0x' + IntToHex (Ord (CallTo [1]), 2) + ') ' + tonumstr;
    line := line + ' : Service : ' + ServiceStr [Ord (Service)] + ' (' + IntToStr (Ord (Service)) + ')' ;
  end;

  Memo2.Lines.Add (line);

  if (CallDaten.Service = DATA_64K) then begin
    Capi1.B1Protokol := HDLC_64k;
    Capi1.B2Protokol := X75;
    Capi1.B3Protokol := B3_TRANSPARENT;

    Capi1Ring := ACCEPT_CALL
  end else if (CallDaten.Service = PACKET_MODE) then begin
    Capi1.B1Protokol := HDLC_64k;
    Capi1.B2Protokol := LAPD;
    Capi1.B3Protokol := ISO8208;

    Capi1Ring := ACCEPT_CALL
  end else if (CallDaten.Service in [TELEPHONY, ANALOG_TELEPHONY, DIGITAL_TELEPHONY]) then begin
  (*
    Capi1.B1Protokol := TRANS_64K;
    Capi1.B2Protokol := BITTRANS;
    Capi1.B3Protokol := B3_TRANSPARENT;
  *)
  (*
    Timer1.Interval := 3000;
    Timer1.Enabled  := true;
  *)
    if (tonumstr = '28') then
      Capi1Ring := ACCEPT_CALL
    else if (tonumstr = '25') then
      Capi1Ring := BUSY_REJECT_CALL
    else
      Capi1Ring := IGNORE_CALL;
  end else Capi1Ring := IGNORE_CALL;
end;

procedure TForm1.Capi1Info(Sender: TObject; const Info: Cardinal; var InfoDaten: CapiParameterType);
var
  line : String;
  nr : LongInt;
begin
  line := 'Info (' + IntToHex (Info,4) + ') : ';

  case (Info and $00FF) of
   $40 : begin
           Move (InfoDaten, nr, 4);
           line := line + 'Gebhren : ' + IntToStr (nr);;
         end;
   $29 : begin
           line := line + 'Datum : ' + IntToStr (Ord (InfoDaten [3])) + '.';
           line := line + IntToStr (Ord (InfoDaten [2])) + '.';
           line := line + '19' + IntToStr (Ord (InfoDaten [1]));
           line := line + ' ' + IntToStr (Ord (InfoDaten [4]));
           line := line + ':' + IntToStr (Ord (InfoDaten [5]));
         end;
   else line := line + InfoDaten;
  end;

  line := Copy (line,1,60);
  Memo2.Lines.Add (line);
end;

procedure TForm1.Capi1Connect(Sender: TObject);
var ncpi : CapiParameterType;
begin
  {$IFDEF DEBUG}
    AssignFile (LogFile,'CAPI.LOG');
    Rewrite (LogFile);
  {$ENDIF}

  {Die weitere Rufannahme verhindern}
  Capi1.EnableListen ([]);

  {Es soll automatisch eine B-Kanal-Verbindung erzeugt werden.}
  if (Capi1.B3Protokol <> ISO8208) then
    Capi1.AutoBConnect := true
  else begin
    Capi1.AutoBConnect := true;

    ncpi [0] := #7;
    ncpi [1] := #0;
    ncpi [2] := #0;
    ncpi [3] := #0;
    ncpi [4] := #3;
    ncpi [5] := 'A';
    ncpi [6] := 'B';
    ncpi [7] := 'C';

    Capi1.OpenBConnect (ncpi);
  end;
end;

function TForm1.Capi1ReqBConnect(Sender:TObject; const DestNCPI : CapiParameterType; var NCPI : CapiParameterType) : Boolean;
var
  i    : Cardinal;
  line : String;
begin
  if (NCPI [0] = #0) then
    Memo2.Lines.Add ('no NCPI')
  else begin
    line := '';
    for i:= 1 to Ord (NCPI [0]) do
      line := line + ' 0x' + IntToHex (Ord (NCPI [i]),2);

    Memo2.Lines.Add ('NCPI' + line);
  end;

  Capi1ReqBConnect := true;
end;

procedure TForm1.Capi1DataConnect(Sender: TObject; const Kanal : BKanalType);
begin
  recvflag := False;
  DataKanal := Kanal;
end;

procedure TForm1.Capi1Receive(Sender: TObject; const Kanal : BKanalType; const Count: Cardinal);
var
  i,
  writeanz : Cardinal;
  line     : String;
  fname    : TFileName;
  buf      : Array [0..2048] of byte;
  last : Integer;
  start,len,check,sum : Cardinal;
begin
//  Memo2.Lines.Add ('Received ' + IntToStr (Count) + ' Bytes');

  Capi1.Read (Kanal,buf,Count);

  {$IFDEF Debug}
    Write (LogFile,Count,' : ');
    if (IOResult <> 0) then;
    if (Count > 40) then
      size := 40
    else size := Count;
    for i:=0 To (size - 1) do begin
      Write (LogFile,IntToHex (Ord (buf [i]),2),' ');
      if (IOResult <> 0) then;
    end;
    WriteLn (LogFile);
    if (IOResult <> 0) then;
    Flush (LogFile);
  {$ENDIF}

  if (buf [0] = 255) and (buf [1] = 0) then begin
    start := Word (buf [2]) * 256 + Word (buf [3]);
    len   := Word (buf [4]) * 256 + Word (buf [5]);
    check := Word (buf [8]) * 256 + Word (buf [9]);

    last := -1;
    sum := 0;
    for i:= start to start + len do begin
      if (last <> -1) then begin
        if (buf [i] <> last) then
          Memo2.Lines.Add ('Fehler bei ' + IntToStr (i));
      end;

      last := (buf [i] + 1) mod 256;
      sum := (sum + buf [i]) mod $10000;
    end;

    if (sum <> check) then
      Memo2.Lines.Add ('Check Fehler');

  end else if (recvflag) then begin
    if (buf [0] = 255) and (buf [1] = 255) then begin
       CloseFile (recvfile);
       recvflag := false;
       line := 'Close File';
    end else begin
      writeanz := Count - 2;
      line := 'Write ' + IntToStr (writeanz) + ' Bytes : ';
      BlockWrite (recvfile,buf [2],writeanz);

      if (IOResult = 0) then
        line := line + ' Ok'
      else line := line + ' Fehler';
      line := 'Write ' + IntToStr (Count) + ' Bytes : ';
    end;

    Memo2.Lines.Add (line);
  end else begin
    if (Capi1.ConnectedService = DATA_64K) then begin
      i:=0;

      repeat
        if (buf [i] = 255) then begin
          Inc (i);

          if (buf [i] = 255) then begin
            Inc (i);

            Move (buf [i], fname, Ord (buf [i]) + 1);
            Inc (i,Ord (buf [i]) + 1);

            AssignFile (recvfile,fname);
            Rewrite (recvfile,1);
            if (IOResult = 0) then begin
              recvflag := true;
              i := Count + 1;
            end;
          end;
        end;

        if not (recvflag) then
          SendMessage (Memo2.Handle,WM_CHAR,Word (buf [i]),0)
        else Memo2.Lines.Add ('Receive file ' + Copy (fname,1,12));

        Inc (i);
      until (i >= (Count - 1));
    end;
  end;
end;

procedure TForm1.DigitalClick(Sender: TObject);
var numstr : String [20];
    adrstr : String [20];
begin
  numstr := InputBox ('Telefonnummer','Rufnummer eingeben','');
  if (Length (numstr) > 0) then begin
    {$IFDEF ProVersion}
    adrstr := InputBox ('SubAdresse','SubAdresse','');
    {$ENDIF}
    Capi1.B1Protokol := HDLC_64k;
    Capi1.B2Protokol := X75;
    Capi1.B3Protokol := B3_TRANSPARENT;

    Capi1.Call (numstr,adrstr,DATA_64K);
  end;
end;

procedure TForm1.DigitalX25Click(Sender: TObject);
var numstr : String [20];
    adrstr : String [20];
begin
  numstr := InputBox ('Telefonnummer','Rufnummer eingeben','');
  if (Length (numstr) > 0) then begin
    {$IFDEF ProVersion}
    adrstr := InputBox ('SubAdresse','SubAdresse','');
    {$ENDIF}
    Capi1.B1Protokol := HDLC_64k;
    Capi1.B2Protokol := X75;
    Capi1.B3Protokol := ISO8208;

    Capi1.Call (numstr,adrstr,PACKET_MODE);
  end;
end;
procedure TForm1.AnalogClick(Sender: TObject);
var numstr : String [20];
begin
  numstr := InputBox ('Telefonnummer','Rufnummer eingeben','');
  if (Length (numstr) > 0) then begin
    Capi1.B1Protokol := TRANS_64K;
    Capi1.B2Protokol := BITTRANS;
    Capi1.B3Protokol := B3_TRANSPARENT;

    Capi1.Call (numstr,'Analog Test',ANALOG_TELEPHONY);
  end;
end;

procedure TForm1.Disconnect1Click(Sender: TObject);
begin
  Capi1.DisconnectLine (1);
end;

procedure TForm1.testtxt1Click(Sender: TObject);
var
  buffer : array [0..2047] of byte;
  len,count,i,sum : Cardinal;
begin
  FillChar (buffer,sizeof (buffer), 0);

  len := 1280;

  buffer [0] := 255;
  buffer [1] := 0;
  buffer [2] := 0;
  buffer [3] := 10;
  buffer [4] := len div 256;
  buffer [5] := len mod 256;

  count := 0;
  sum := 0;
  for i:=10 to 10 + len do begin
    buffer [i] := count;
    sum := (sum + buffer [i]) mod $10000;
    count := (count + 1) mod 256;
  end;

  buffer [8] := sum div 256;
  buffer [9] := sum mod 256;

  Capi1.Write (DataKanal,buffer,2048);
  Capi1.Write (DataKanal,buffer,2048);
  Capi1.Write (DataKanal,buffer,2048);
  Capi1.Write (DataKanal,buffer,2048);
  Capi1.Write (DataKanal,buffer,2048);
  Capi1.Write (DataKanal,buffer,2048);
  Capi1.Write (DataKanal,buffer,2048);
  Capi1.Write (DataKanal,buffer,2048);
end;

procedure TForm1.FormCreate(Sender: TObject);
var err : Integer;
begin
  Capi1 := TCapi20Handler.Create (Self);

  Capi1.Controller   := 1;
  Capi1.OwnNumber    := '19';
  {$IFDEF ProVersion}
  Capi1.OwnSubAdr    := 'CAPI 2.0';
  {$ENDIF}
  Capi1.Infos        := [Gebuehren,DatumZeit,Display,UserToUser,Facilities,DisconnectCause,RufStatus,CalledNumber];
  Capi1.AutoBConnect := false;

  Capi1.OnError           := Capi1Error;
  Capi1.OnConfirm         := Capi1Confirm;
  Capi1.MessageDump       := Capi1MessageDump;
  Capi1.OnRing            := Capi1Ring;
  Capi1.OnConnect         := Capi1Connect;
  Capi1.OnBConnect        := Capi1DataConnect;
  Capi1.OnRequestBConnect := Capi1ReqBConnect;
  Capi1.OnReceive         := Capi1Receive;
  Capi1.OnInfo            := Capi1Info;
  Capi1.OnDisconnect      := Capi1Disconnect;
  Capi1.OnReceiveDTMF     := Capi1ReceiveDTMF;
  Capi1.OnSetBProtokollEvent := CapiSetProtokoll;

  Capi1.RegisterApplication;

  err := Capi1.GetLastError;
  if (err <> 0) then
    MessageDLG ('Fehler bei der CAPI-Anmeldung: ' + Capi1.GetErrorStr (err), mtWarning, [mbOK],0);
end;

procedure TForm1.Ein1Click(Sender: TObject);
var enableset : TServiceSet;
begin
  enableset := [];

  if (Telephony1.Checked) then
    enableset := enableset + [TELEPHONY, ANALOG_TELEPHONY, DIGITAL_TELEPHONY];

  if (Daten1.Checked) then
    enableset := enableset + [DATA_64k];

  if (FaxG31.Checked) then
    enableset := enableset + [FAX3];

  if (FaxG41.Checked) then
    enableset := enableset + [FAX4];

  if (Packet1.Checked) then
    enableset := enableset + [PACKET_MODE];

  Capi1.EnableListen (enableset);
end;

procedure TForm1.Aus1Click(Sender: TObject);
begin
  Capi1.EnableListen ([]);
end;

procedure TForm1.Select1Click(Sender: TObject);
type
  bufarray = array [1..8196] of char;
var
  filevar : File;
  fname   : TFileName;
  line    : String;
  time    : DWORD;
  err,
  strpos  : Word;
  maxread,
  readanz : Cardinal;
  size    : LongInt;
  buf     : ^bufarray;
begin
  OpenFileDialog.FileName := '*.*';

  if OpenFileDialog.Execute then Begin
    AssignFile (filevar,OpenFileDialog.FileName);

    Reset (filevar,1);
    if (IOResult <> 0) Then
      MessageDLG ('Datei ' + OpenFileDialog.FileName + ' kann nicht geffnet werden', mtWarning, [mbOK], 0)
    else begin
      size:=FileSize (filevar);

      fname := OpenFileDialog.FileName;

      repeat
        strpos := Pos ('\',fname);
        if (strpos > 0) then
          Delete (fname,1,strpos);
      until (strpos = 0);

      line:=#255 + #0 + Chr (Length (fname)) + fname;
      Capi1.Write (DataKanal,line [1],Length (line));

      GetMem (buf,8196);

      time := GetTickCount;

      err := 0;

      while not eof (filevar) and (err = 0) do begin
        maxread := Capi1.BDataBlockSize - 2;

        BlockRead (filevar,buf^[3],maxread,readanz);

        if (IOResult <> 0) then begin
          err := 1;
          MessageDLG ('Lesefehler in ' + OpenFileDialog.FileName, mtWarning, [mbOK], 0)
        end else begin
          Memo1.Lines.Add ('Send ' + IntToStr (readanz) + ' Bytes');

          if (readanz > 0) then begin
            buf^[1] := #255;
            buf^[2] := #3;

            if (Capi1.Write (DataKanal,buf^,readanz + 2) <> (readanz + 2)) then
              err := 2;
          end;
        end;
      end;

      time := GetTickCount - time;
      line := IntToStr (time) + ' ms / ';
      if (time <> 0) then
        line := line + IntToStr (1000 * size Div time)
      else line := line + '---';
      line:= line + ' Bytes/Sec';

      Memo2.Lines.Add (line);

      FreeMem (buf,8196);

      line:=#255 + #1;
      Capi1.Write (DataKanal,line [1],Length (line));

      CloseFile (filevar);
    end;
  end;
end;

procedure TForm1.Capi1Disconnect(Sender: TObject; const Grund: Cardinal);
begin
  Memo2.Lines.Add ('Disconnect: ' + Capi1.GetDisconnectReasenStr (Grund));

  if (recvflag) then
    CloseFile (recvfile);

  recvflag := false;

{$IFDEF Denug}
  CloseFile (LogFile);
{$ENDIF}
end;

procedure TForm1.DTMF1Click(Sender: TObject);
var req  : RequestDatenType;
begin
  FillChar (req,sizeof (req),0);

  req.FacilityReq.NCCI := DataKanal;
  req.FacilityReq.Selector := SelectorDTMF;
  req.FacilityReq.Size := 15;
  req.FacilityReq.Parameter.FunctionCode := SendDTMFDigits;
  req.FacilityReq.Parameter.ToneDuration := 40;
  req.FacilityReq.Parameter.GapDuration  := 40;
  req.FacilityReq.Parameter.Digits [0] := #7;
  req.FacilityReq.Parameter.Digits [1] := '1';
  req.FacilityReq.Parameter.Digits [2] := '2';
  req.FacilityReq.Parameter.Digits [3] := '3';
  req.FacilityReq.Parameter.Digits [4] := '4';
  req.FacilityReq.Parameter.Digits [5] := '5';
  req.FacilityReq.Parameter.Digits [6] := '6';
  req.FacilityReq.Parameter.Digits [7] := '7';

  Capi1.SendRequestMessage (FACILITY,req);
end;

procedure TForm1.Anmelden1Click(Sender: TObject);
begin
  Capi1.RegisterApplication;
end;

procedure TForm1.Abmelden1Click(Sender: TObject);
begin
  Capi1.ReleaseApplication;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Capi1.ReleaseApplication;
  Capi1.Destroy;
end;

procedure TForm1.Connect1Click(Sender: TObject);
var line : CapiParameterType;
begin
  line := '';

  if not (Capi1.OpenBConnect (line)) then
    MessageDLG ('B-Verbindung nicht aufgebaut', mtWarning, [mbOK], 0);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled  := false;

  Capi1.AnswerCall (OUT_OF_ORDER_REJECT_CALL);
end;

procedure TForm1.Telephony1Click(Sender: TObject);
begin
  with Sender as TMenuItem do Checked := not (Checked);
end;

procedure TForm1.Daten1Click(Sender: TObject);
begin
  with Sender as TMenuItem do Checked := not (Checked);
end;

procedure TForm1.FAXG31Click(Sender: TObject);
begin
  with Sender as TMenuItem do Checked := not (Checked);
end;

procedure TForm1.FAXG41Click(Sender: TObject);
begin
  with Sender as TMenuItem do Checked := not (Checked);
end;

procedure TForm1.FacilitySupportClick(Sender: TObject);
var req  : RequestDatenType;
begin
  FillChar (req,sizeof (req),0);

  req.FacilityReq.NCCI := 1;
  req.FacilityReq.Selector := SelectorSupService;
  req.FacilityReq.Size := 3;
  req.FacilityReq.SupplementService.Funct := SupSupported;

  Capi1.SendRequestMessage (FACILITY,req);
end;

procedure TForm1.Setup1Click(Sender: TObject);
begin
  Form2.Edit1.Text := Capi1.OwnNumber;
  Form2.Edit2.Text := Capi1.OwnSubAdr;
  Form2.CheckBox1.Checked := Capi1.NebenStelle;
  Form2.Edit4.Text := Capi1.AmtNr;
  Form2.Edit3.Text := IntToStr (Capi1.ExternLen);

  Form2.SetupAmtGroup;
  Form2.Top := Top + 40;
  Form2.Left := Left + 40;

  if (Form2.ShowModal = mrOk) then begin
    Capi1.OwnNumber    := Form2.Edit1.Text;
    Capi1.OwnSubAdr    := Form2.Edit2.Text;
    Capi1.NebenStelle  := Form2.CheckBox1.Checked;
    Capi1.AmtNr        := Form2.Edit4.Text;
    Capi1.ExternLen    := StrToInt (Form2.Edit3.Text)
  end;
end;

procedure TForm1.Packet1Click(Sender: TObject);
begin
  with Sender as TMenuItem do Checked := not (Checked);
end;

procedure TForm1.Daten2Click(Sender: TObject);
begin
  Capi1.B1Protokol := HDLC_64k;
  Capi1.B2Protokol := X75;
  Capi1.B3Protokol := B3_TRANSPARENT;
end;

procedure TForm1.Voice1Click(Sender: TObject);
begin
  Capi1.B1Protokol := TRANS_64K;
  Capi1.B2Protokol := BITTRANS;
  Capi1.B3Protokol := B3_TRANSPARENT;
end;

procedure TForm1.Fax1Click(Sender: TObject);
begin
  Capi1.B1Protokol := T30_B1;
  Capi1.B2Protokol := T30_B2;
  Capi1.B3Protokol := T30_B3;
end;

procedure TForm1.Set1Click(Sender: TObject);
var line : CapiParameterType;
begin
  if not (Capi1.OpenBConnect (line)) then
    MessageDLG ('B-Verbindung nicht aufgebaut', mtWarning, [mbOK], 0);
end;

procedure TForm1.Reset1Click(Sender: TObject);
begin
  if not (Capi1.CloseBConnect (DataKanal, '')) then
    MessageDLG ('B-Verbindung nicht aufgebaut', mtWarning, [mbOK], 0);

end;

procedure TForm1.Capi1ReceiveDTMF (Sender:TObject; const Taste : char);
begin
  Memo3.Lines.Add ('DTMF: ' + Taste);
end;


procedure TForm1.Handset1Click(Sender: TObject);
var req  : RequestDatenType;
begin
  FillChar (req,sizeof (req),0);

  req.FacilityReq.NCCI := $81;
  req.FacilityReq.Selector := 0;
  req.FacilityReq.Size := 0;

  Capi1.SendRequestMessage (FACILITY,req);
end;

procedure TForm1.CapiSetProtokoll (Sender:TObject; var Param : CapiBProtocolType);
var
  i : Cardinal;
  line : String;
begin
  With Sender as TCapi20Handler do begin
    if (B3Protokol = T30_B3) then begin
      Param.B1Configuration.Size := 8;
      FillChar (Param.B1Configuration.B1Param, 8, 0);

      with Param.B3FaxConfiguration do begin
        Format     := 0;
        Resolution := 0;

        line := '+49 123 23456';
        StationID [0] := Chr (Length (line));
        for i:=1 to Length (line) do
          StationID [i] := line [i];

        line := 'CapiTest';
        HeaderLine [0] := Char (Length (line));
        for i:=1 to Length (line) do
          HeaderLine [i] := line [i];
      end;
    end;
  end;
end;

procedure TForm1.CapiGetProtokoll (Sender:TObject; const NCPI : CapiParameterType);
var len : Cardinal;
begin
  With Sender as TCapi20Handler do begin
    if (B3Protokol = T30_B3) then begin
      FillChar (FaxRecvInfo,sizeof (FaxRecvInfo),0);
      if (Ord (NCPI [0]) <> 0) then begin
        with FaxRecvInfo do begin
          System.Move (NCPI [1], Baudrate, 2);
          System.Move (NCPI [3], Resolution, 2);
          System.Move (NCPI [5], Format, 2);
          System.Move (NCPI [7], Pages, 2);

          len := Ord (NCPI [9]);
          if (len > sizeof (RecevierID) - 1) then
            len := sizeof (RecevierID) - 1;
          System.Move (NCPI [10], RecevierID [1], len);
          {$IFDEF Win32}
            SetLength (RecevierID, len);
          {$ELSE}
            RecevierID [0] := Chr (len);
          {$ENDIF}
        end;
      end;
    end;
  end;
end;

procedure TForm1.Suspend1Click(Sender: TObject);
var req  : RequestDatenType;
begin
  FillChar (req,sizeof (req),0);

  req.FacilityReq.NCCI := DataKanal;
  req.FacilityReq.Selector := 3;
  req.FacilityReq.Size := 7;
  req.FacilityReq.SupplementService.Funct := SupSuspend;
  req.FacilityReq.SupplementService.Param [0] := #3;
  req.FacilityReq.SupplementService.Param [1] := #2;
  req.FacilityReq.SupplementService.Param [2] := #$30;
  req.FacilityReq.SupplementService.Param [3] := '1';

  Capi1.SendRequestMessage (FACILITY,req);
end;

procedure TForm1.Resume1Click(Sender: TObject);
var req  : RequestDatenType;
begin
  FillChar (req,sizeof (req),0);

  req.FacilityReq.NCCI := DataKanal;
  req.FacilityReq.Selector := 3;
  req.FacilityReq.Size := 7;
  req.FacilityReq.SupplementService.Funct := SupResume;
  req.FacilityReq.SupplementService.Param [0] := #3;
  req.FacilityReq.SupplementService.Param [1] := #2;
  req.FacilityReq.SupplementService.Param [2] := #$30;
  req.FacilityReq.SupplementService.Param [3] := '1';

  Capi1.SendRequestMessage (FACILITY,req);
end;

procedure TForm1.ListenDTMF1Click(Sender: TObject);
var req  : RequestDatenType;
begin
  FillChar (req,sizeof (req),0);

  req.FacilityReq.NCCI := DataKanal;
  req.FacilityReq.Selector := SelectorDTMF;
  req.FacilityReq.Size := 2;
  req.FacilityReq.Parameter.FunctionCode := StartDTMFListen;

  Capi1.SendRequestMessage (FACILITY,req);
end;

procedure TForm1.Ein2Click(Sender: TObject);
begin
  Aus2.Checked := false;
  Ein2.Checked := true;

  Capi1.OnReceiveDTMF := Capi1ReceiveDTMF;
end;

procedure TForm1.Aus2Click(Sender: TObject);
begin
  Aus2.Checked := true;
  Ein2.Checked := false;

  Capi1.OnReceiveDTMF := Nil;
end;

procedure TForm1.Reset2Click(Sender: TObject);
begin
  if not (Capi1.ResetBConnect (DataKanal,'')) then
    MessageDLG ('B-Verbindung nicht zurckgesetzt', mtWarning, [mbOK], 0);
end;

procedure TForm1.ExtFax1Click(Sender: TObject);
begin
  Capi1.B1Protokol := T30_B1;
  Capi1.B2Protokol := T30_B2;
  Capi1.B3Protokol := T30_EXT;
end;

end.
