{$I-}
unit isdnfaxmain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, Capi2Bas, Capi2han, Capi2Con, Capi2Typ, StdCtrls,
  MPlayer, ExtCtrls, ComCtrls, CapiProt, SffConverter, T30Protokoll, FaxTransfer;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Exit1: TMenuItem;
    CAPIDisplay: TMemo;
    ListBox1: TListBox;
    MsnNeu: TButton;
    MsnDel: TButton;
    ListBox2: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    RingTimer: TTimer;
    Auflegen1: TMenuItem;
    StatusBar1: TStatusBar;
    T30Protokoll1: TT30Protokoll;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    Faxgert1: TMenuItem;
    Ein1: TMenuItem;
    Aus1: TMenuItem;
    CapiHandler: TCapi20Handler;
    Senden1: TMenuItem;
    Label3: TLabel;
    Label4: TLabel;

    function CapiHandlerRing(Sender: TObject;const CallDaten : TCallDaten) : Cardinal;
    procedure Exit1Click(Sender: TObject);
    procedure Ein1Click(Sender: TObject);
    procedure Aus1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy (Sender: TObject);
    procedure CapiHandlerMessageDump(Sender: TObject; const CommandID,
      SubCommand: Cardinal; var Daten: ReceiveDatenType);
    procedure CapiHandlerBConnect(Sender: TObject; const NCCI: LongInt);
    procedure CapiHandlerBDisconnect(Sender: TObject; const NCCI: Longint;
    const Grund: Cardinal);
    procedure CapiHandlerDisconnect(Sender: TObject;
      const Grund: Cardinal);
    procedure CapiHandlerError(Sender: TObject; const CommandID,
      SubCommand, ErrorNumber: Cardinal);
    procedure ListBox1DblClick(Sender: TObject);
    procedure MsnNeuClick(Sender: TObject);
    procedure MsnDelClick(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListBox2KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure OnRingTimer(Sender: TObject);
    procedure Auflegen1Click(Sender: TObject);
    procedure CapiHandlerConnect(Sender: TObject);
    procedure Senden1Click(Sender: TObject);
  private
    abKanal : BKanalType;

    FaxSendMode : Cardinal;
    FaxRecvFileName,
    FaxSendFileName : TFilename;
    RufAnnahme : Boolean;
    AnrufIndex : Integer;
    AnswerWait,
    AntwortDauer : LongInt;
    ShowIndex : Integer;
    RufNummer : TStringList;
    Anrufe : TStringList;
    TransferStatus : TFaxTransfer;
    LastCallReturn : Cardinal;
    LastCallDaten : TCallDaten;

    procedure AnrufAufzeichen    (var Msg : TMessage); message WM_USER + 1;
    procedure AnrufSignalisieren (var Msg : TMessage); message WM_USER + 2;

    procedure Abbrechen (Sender: TObject);
    procedure FaxVersenden (const FileName : TFilename);

    procedure CheckCall;

    function ReadConfig : Integer;
    function SaveConfig : Integer;

    function GetFileName (const Index : Integer) : String;
    function GetAnrufNummer (const Index : Integer) : String;
    function GetAnrufKennung (const Index : Integer) : String;
    function GetRufNummer (const Index : Integer) : String;
    function GetRufKennung (const Index : Integer) : String;
    function GetStationKennung (const Index : Integer) : String;
    function GetFaxVerzeichnis (const Index : Integer) : String;

  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

uses msninput;

{$R *.DFM}

type
  ByteArray     = array [0..$fff0] of Byte;
  SmallIntArray = array [0..$7ff0] of SmallInt;

var LastTempNr : Cardinal;

function GetTempFile (const DirName, ExtName : String) : String;
var path : String;
begin
  path := DirName;
  if (Length (path) > 0) and (path [Length (path)] <> '\') then path := path + '\';

  while (LastTempNr < 99999999) and FileExists (path + IntToStr (LastTempNr) + '.' + ExtName) do
    Inc (LastTempNr);

  if (LastTempNr > 99999999) then
    GetTempFile := ''
  else GetTempFile := path + IntToStr (LastTempNr) + '.' + ExtName;
end;

function TForm1.GetAnrufNummer (const Index : Integer) : String;
var
  line     : String;
begin
  line := Anrufe [Index];
  GetAnrufNummer := Copy (line,1,Pos (';',line) - 1);
end;

function TForm1.GetFileName (const Index : Integer) : String;
var
  line     : String;
  startpos : Cardinal;
begin
  line := Anrufe [Index];
  startpos := Pos (';',line);
  Delete (line,1,startpos);
  GetFileName := Copy (line,1,Pos (';',line) - 1);
end;

function TForm1.GetAnrufKennung (const Index : Integer) : String;
var
  line     : String;
  startpos : Cardinal;
begin
  line := Anrufe [Index];
  startpos := Pos (';',line);
  Delete (line,1,startpos);
  startpos := Pos (';',line);
  Delete (line,1,startpos);
  GetAnrufKennung := line;
end;

function TForm1.GetRufNummer (const Index : Integer) : String;
var
  line     : String;
begin
  line := RufNummer [Index];
  GetRufNummer := Copy (line,1,Pos (';',line) - 1);
end;

function TForm1.GetRufKennung (const Index : Integer) : String;
var
  line     : String;
  startpos : Cardinal;
begin
  line := RufNummer [Index];
  startpos := Pos (';',line);
  Delete (line,1,startpos);
  GetRufKennung := Copy (line,1,Pos (';',line) - 1);
end;

function TForm1.GetStationKennung (const Index : Integer) : String;
var
  line     : String;
  startpos : Cardinal;
begin
  line := RufNummer [Index];
  startpos := Pos (';',line);
  Delete (line,1,startpos);
  startpos := Pos (';',line);
  Delete (line,1,startpos);

  startpos := Pos (';',line);
  if (startpos = 0) then
    GetStationKennung := line
  else GetStationKennung := Copy (line,1, startpos - 1);
end;

function TForm1.GetFaxVerzeichnis (const Index : Integer) : String;
var
  line     : String;
  startpos : Cardinal;
begin
  line := RufNummer [Index];
  startpos := Pos (';',line);
  Delete (line,1,startpos);
  startpos := Pos (';',line);
  Delete (line,1,startpos);

  startpos := Pos (';',line);
  if (startpos = 0) then
    GetFaxVerzeichnis := ''
  else begin
    Delete (line,1,startpos);

    GetFaxVerzeichnis := line;
  end;
end;

procedure TForm1.AnrufSignalisieren (var Msg : TMessage);
begin
  TransferStatus.Rufannahme;
end;

procedure TForm1.AnrufAufzeichen (var Msg : TMessage);
var
  fname   : String;
  readanz : Cardinal;
  buffer : array [0..2047] of byte;

begin
  TransferStatus.Aufbau;

  if (FaxSendMode = 1) then begin
    T30Protokoll1.SendFax (FaxSendFileName);
    CapiHandler.DisconnectLine (0);
  end else begin
    AntwortDauer := GetTickCount;

    if (AnrufIndex <> -1) then
      Anrufe [AnrufIndex] := Anrufe [AnrufIndex] + ';' + FaxRecvFileName;

    T30Protokoll1.ReceiveFax (FaxRecvFileName);
  end;

  TransferStatus.Abbau;
  CapiHandler.DisconnectLine (0);
end;

procedure TForm1.CapiHandlerBConnect(Sender: TObject; const NCCI: LongInt);
begin
  abKanal := NCCI;

  PostMessage (Handle, wm_user + 1, 0, 0);
end;

procedure TForm1.CheckCall;
var
  i       : Cardinal;
  found   : Boolean;
  numstr  : String [26];
  line    : String;
  fname,
  dirstr  : TFilename;
  nowtime : TDateTime;
begin
  with LastCallDaten do begin
    line := Copy (CallFrom,3,Length (CallFrom) - 2);
    line := line + ' fr ' + Copy (CallTo,2,Length (CallTo) - 1);

    if not (Service in [FAX3, ANALOG_TELEPHONY, DIGITAL_TELEPHONY]) then
      LastCallReturn := IGNORE_CALL
    else begin
      i := 0;
      found := false;
      numstr := Copy (CallTo,2,Length (CallTo) - 1);

      while not (found) and (i < RufNummer.Count) do begin
        if (GetRufNummer (i) = numstr) then
          found := true
        else Inc (i);
      end;

      if not (found) then
        LastCallReturn := IGNORE_CALL
      else begin
        nowtime := Now;
        line := DateToStr (nowtime) + ' ' + TimeToStr (nowtime);
        line := line + ' : Anruf von ';
        if (Length (CallFrom) = 0) then
          line := line + 'unbekannt'
        else if (CallFrom [2] = #$A0) then
          line := line + 'anonym'
        else line := line + Copy (CallFrom,3,Length (CallFrom) - 2);

        line := line + ' fr ' + Copy (CallTo,2,Length (CallTo) - 1);

        AnrufIndex := Anrufe.Add (line);
        ListBox2.Items.Insert (AnrufIndex,Anrufe [AnrufIndex]);

        T30Protokoll1.FaxSendInfo.HeaderLine := GetRufKennung (i);
        T30Protokoll1.FaxSendInfo.StationID  := GetStationKennung (i);

        fname := GetTempFile ('','sff');

        if (Length (fname) = 0) then
          LastCallReturn := IGNORE_CALL
        else begin
          dirstr := GetFaxVerzeichnis (i);

          if (Length (dirstr) > 0) then
            FaxRecvFileName := dirstr + '\' + fname
          else FaxRecvFileName := fname;

          LastCallReturn := ACCEPT_CALL;
        end;
      end;
    end;
  end;
end;

function TForm1.CapiHandlerRing(Sender: TObject;const CallDaten : TCallDaten) : Cardinal;
begin
  LastCallReturn := IGNORE_CALL;
  LastCallDaten := CallDaten;

  with Sender as TCapi20Handler do begin
    Synchronize (CheckCall);

    if (LastCallReturn <> ACCEPT_CALL) then
      CapiHandlerRing := LastCallReturn
    else begin
      PostMessage (Handle, wm_user + 2, 0, 0);

      EnableListen ([]);

      B1Protokol := T30_B1;
      B2Protokol := T30_B2;
      B3Protokol := T30_B3;

      AnswerWait := GetTickCount + 5000;

      CapiHandlerRing := WAIT_ACCEPT_CALL
    end;
  end;
end;


procedure TForm1.CapiHandlerDisconnect(Sender: TObject; const Grund: Cardinal);
begin
  TransferStatus.Ende;

  FaxSendMode := 0;

  AnswerWait := -1;
  AntwortDauer := GetTickCount - AntwortDauer;

  if (AnrufIndex <> -1) then
    Anrufe [AnrufIndex] := Anrufe [AnrufIndex] + ';' + T30Protokoll1.FaxRecvInfo.RecevierID;

  AntwortDauer := 0;
  AnrufIndex   := -1;

  if RufAnnahme then
    CapiHandler.EnableListen ([FAX3, ANALOG_TELEPHONY, DIGITAL_TELEPHONY]);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  if CapiHandler.ApplicationRegistered then
    CapiHandler.EnableListen ([]);

  Close;
end;

procedure TForm1.Ein1Click(Sender: TObject);
begin
  if not (CapiHandler.ApplicationRegistered) then
    MessageDLG ('CAPI nicht verfgbar', mtWarning, [mbOK], 0)
  else begin
    RufAnnahme := true;

    CapiHandler.EnableListen ([ANALOG_TELEPHONY, DIGITAL_TELEPHONY]);
  end;
end;

procedure TForm1.Aus1Click(Sender: TObject);
begin
  if not (CapiHandler.ApplicationRegistered) then
    MessageDLG ('CAPI nicht verfgbar', mtWarning, [mbOK], 0)
  else begin
    RufAnnahme := false;

    CapiHandler.EnableListen ([]);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  i      : Cardinal;
  start,
  strpos : Cardinal;
  line   : String;
begin
  Anrufe := TStringList.Create;
  RufNummer := TStringList.Create;
  TransferStatus := TFaxTransfer.Create (Self);

  TransferStatus.FaxProtokoll := T30Protokoll1;
  TransferStatus.Abort        := Abbrechen;
  ShowIndex := -1;

  if (FileExists ('recvfax.dat')) then begin
    Anrufe.LoadFromFile ('recvfax.dat');

    if (IOResult <> 0) then;
    
    if (Anrufe.Count > 0) then begin
      for i:=0 to Anrufe.Count - 1 do begin
        line := Anrufe [i];

        strpos := Pos (';',line);
        start := strpos;
        Inc (strpos);
        while (strpos <= Length (line)) and (line [strpos] <> ';') do Inc (strpos);
        Delete (line,start,(strpos - start) + 1);

        ListBox2.Items.Insert (i,line);
      end;
    end;
  end;

  CapiHandler.BDataBlockSize := 2048;

  RufAnnahme  := false;
  AnswerWait  := -1;
  AnrufIndex  := -1;

  ListBox1.Items.Clear;
  ReadConfig;

  if CapiHandler.CapiAvailable and not (CapiHandler.ApplicationRegistered) then
    CapiHandler.RegisterApplication;
end;

procedure TForm1.CapiHandlerMessageDump(Sender: TObject; const CommandID,
  SubCommand: Cardinal; var Daten: ReceiveDatenType);
begin
  if (CommandID <> DATA_B3) then
    CAPIDisplay.Lines.Add (CapiHandler.GetCommandStr (CommandID,SubCommand));
end;

procedure TForm1.CapiHandlerBDisconnect(Sender: TObject; const NCCI : LongInt; const Grund: Cardinal);
var line : String;
begin
  TransferStatus.Abbau;

  if (FaxSendMode = 0) then begin
    line := 'Empfangen von ' + T30Protokoll1.FaxRecvInfo.RecevierID + ' mit ' + IntToStr (T30Protokoll1.FaxRecvInfo.Baudrate);
  end else begin
    line := 'Gesendet an ' + T30Protokoll1.FaxRecvInfo.RecevierID + ' mit ' + IntToStr (T30Protokoll1.FaxRecvInfo.Baudrate);
  end;

  Memo1.Lines.Add (line);

  FaxSendMode := 0;
end;

procedure TForm1.CapiHandlerError(Sender: TObject; const CommandID,
  SubCommand, ErrorNumber: Cardinal);
begin
  if (CommandID = 0) then
    MessageDLG (CapiHandler.GetErrorStr (ErrorNumber), mtWarning, [mbOK], 0)
  else
    MessageDLG (CapiHandler.GetCommandStr (CommandID,SubCommand) + ' : ' +
    CapiHandler.GetErrorStr (ErrorNumber), mtWarning, [mbOK], 0);
end;

procedure TForm1.FormDestroy (Sender: TObject);
begin
  if (RufNummer <> nil) then
    RufNummer.SaveToFile ('sendfax.dat');

  RufNummer.Free;

  if (Anrufe <> nil) then
    Anrufe.SaveToFile ('recvfax.dat');

  Anrufe.Free;

  TransferStatus.Free;

  if CapiHandler.ApplicationRegistered then
    CapiHandler.ReleaseApplication;
end;

function TForm1.ReadConfig : Integer;
var
  line    : String;
  auswahl : Cardinal;
  cfgfile : TextFile;
begin
  AssignFile (cfgfile,'fax.ini');
  Reset (cfgfile);
  if (IOResult <> 0) then
    ReadConfig := -1
  else begin
    auswahl := 0;
    ListBox1.Items.Clear;

    while not (Eof (cfgfile)) do begin
      ReadLn (cfgfile,line);
      if (line [1] = '[') then begin
        if (Pos ('[LISTEN_MSN]',line) <> 0) then
          auswahl := 1;
      end else begin
        case auswahl of
          1 : begin
                RufNummer.Add (line);
                ListBox1.Items.Add (GetRufNummer (RufNummer.Count - 1));
              end;
        end;
      end;
    end;

    CloseFile (cfgfile);

    ReadConfig := 0;
  end;
end;

function TForm1.SaveConfig : Integer;
var
  i       : Cardinal;
  cfgfile : TextFile;
begin
  AssignFile (cfgfile,'fax.ini');
  Rewrite (cfgfile);
  if (IOResult <> 0) then
    SaveConfig := -1
  else begin
    WriteLn (cfgfile,'[LISTEN_MSN]');

    for i:=0 to (ListBox1.Items.Count - 1) do
      WriteLn (cfgfile,RufNummer [i]);

    CloseFile (cfgfile);

    SaveConfig := 0;
  end;
end;
procedure TForm1.ListBox1DblClick(Sender: TObject);
begin
  if (ListBox1.ItemIndex <> -1) then begin
    Form3.Left := Left + 10;
    Form3.Top  := Top + 10;
    Form3.Edit1.Text := GetRufNummer (ListBox1.ItemIndex);
    Form3.Edit2.Text := GetRufKennung (ListBox1.ItemIndex);
    Form3.Edit3.Text := GetStationKennung (ListBox1.ItemIndex);
    Form3.Edit4.Text := GetFaxVerzeichnis (ListBox1.ItemIndex);

    if (Form3.ShowModal = mrOk) then begin
      RufNummer [ListBox1.ItemIndex] := Form3.Edit1.Text + ';' + Form3.Edit2.Text + ';' + Form3.Edit3.Text + ';' + Form3.Edit4.Text;
      ListBox1.Items [ListBox1.ItemIndex] := Form3.Edit1.Text;

      SaveConfig;
    end;
  end;
end;

procedure TForm1.MsnNeuClick(Sender: TObject);
begin
  Form3.Left := Left + 10;
  Form3.Top  := Top + 10;

  Form3.Edit1.Text := '';
  Form3.Edit2.Text := '';
  if (RufNummer.Count = 0) then
    Form3.Edit3.Text := ''
  else Form3.Edit3.Text := GetStationKennung (0);
  Form3.Edit4.Text := '';

  if (Form3.ShowModal = mrOk) then begin
    RufNummer.Add (Form3.Edit1.Text + ';' + Form3.Edit2.Text + ';' + Form3.Edit3.Text+';' + Form3.Edit4.Text);
    ListBox1.Items.Add (Form3.Edit1.Text);

    SaveConfig;
  end;
end;

procedure TForm1.MsnDelClick(Sender: TObject);
begin
  if (ListBox1.ItemIndex <> -1) then begin
    RufNummer.Delete (ListBox1.ItemIndex);
    ListBox1.Items.Delete (ListBox1.ItemIndex);

    SaveConfig;
  end;
end;

procedure TForm1.ListBox2Click(Sender: TObject);
var fname : TFilename;
begin
  if (ListBox2.ItemIndex <> -1) then begin
    fname := GetFilename (ListBox2.ItemIndex);
    if (Length (fname) = 0) then
      MessageDLG ('Es ist kein Faxdokument zu diesem Eintrag vorhanden', mtError, [mbOK], 0)
    else begin
    end;
  end;
end;

procedure TForm1.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var numstr : String [20];
begin
  if (ListBox1.ItemIndex <> -1) then begin
    if (Key = VK_DELETE) then begin
      if (MessageDLG ('Nummer wirklich lschen', mtConfirmation, [mbCancel,mbOK], 0) = mrOK) then begin
        ListBox1.Items.Delete (ListBox1.ItemIndex);

        SaveConfig;
      end;
    end else if (Key = VK_INSERT) then begin
      numstr := InputBox ('Telefonnummer','Neue Rufnummer eingeben','');
      if (Length (numstr) > 0) then begin
        ListBox1.Items.Add (numstr);

        SaveConfig;
      end;
    end;
  end;
end;

procedure TForm1.ListBox2KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var tmpstr : array [0..128] of char;
begin
  if (ListBox2.ItemIndex <> -1) then begin
    if (Key = VK_DELETE) then begin
      if (MessageDLG ('Eintrag wirklich lschen', mtConfirmation, [mbCancel,mbOK], 0) = mrOK) then begin
        {$IFDEF Win32}
          DeleteFile (StrPCopy (tmpstr, GetFileName (ListBox2.ItemIndex)));
        {$ELSE}
          DeleteFile (GetFileName (ListBox2.ItemIndex));
        {$ENDIF}
        Anrufe.Delete (ListBox2.ItemIndex);
        ListBox2.Items.Delete (ListBox2.ItemIndex);
      end;
    end;
  end;
end;

procedure TForm1.OnRingTimer(Sender: TObject);
var time : LongInt;
begin
  if (AnswerWait <> -1) then begin
    if (GetTickCount > AnswerWait) then begin
      AnswerWait := -1;
      CapiHandler.AnswerCall (ACCEPT_CALL);
    end;
  end;

  if (AntwortDauer <> 0) then begin
    time := (GetTickCount - AntwortDauer) div 1000;
    StatusBar1.Panels [1].Text := IntToStr (time div 60) + ':' + IntToStr (time mod 60);
  end;
end;

procedure TForm1.Auflegen1Click(Sender: TObject);
begin
  CapiHandler.DisconnectLine (0);
end;


procedure TForm1.FaxVersenden (const FileName : TFilename);
var numstr : String [20];
begin
  if (FileExists (FileName)) then begin
    FaxSendFileName := FileName;

    numstr := InputBox ('Telefonnummer','Rufnummer eingeben','');
    if (Length (numstr) > 0) then begin
      FaxSendMode := 1;

      CapiHandler.B1Protokol := T30_B1;
      CapiHandler.B2Protokol := T30_B2;
      CapiHandler.B3Protokol := T30_B3;

      T30Protokoll1.FaxSendInfo.HeaderLine := GetRufKennung (0);
      T30Protokoll1.FaxSendInfo.StationID  := GetStationKennung (0);

      if (CapiHandler.Call (numstr,'SendFax',ANALOG_TELEPHONY)) then
        TransferStatus.Anwahl;
    end;
  end;
end;

procedure TForm1.CapiHandlerConnect(Sender: TObject);
begin
  TransferStatus.Aufbau;
end;

procedure TForm1.Abbrechen (Sender: TObject);
begin
  T30Protokoll1.AbortTransfer;
  TransferStatus.Abbau;
  CapiHandler.DisconnectLine (0);
end;

procedure TForm1.Senden1Click(Sender: TObject);
begin
  OpenDialog1.FileName := '*.sff';

  if OpenDialog1.Execute then begin
    if (FileExists (OpenDialog1.FileName)) then begin
      FaxVersenden (OpenDialog1.FileName);
    end;
  end;
end;

initialization
  LastTempNr := 0;
end.
